/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.237 Revision 1.368
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.237 2006/06/04 15:18:12 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.368 2011/10/27 07:16:08 vapier Exp $
4#
5# This eclass is for general purpose functions that most ebuilds
6# have to implement themselves.
7#
8# NB: If you add anything, please comment it!
9 4
5# @ECLASS: eutils.eclass
6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
17
10inherit multilib portability 18inherit multilib portability user
11
12DEPEND="!bootstrap? ( sys-devel/patch )"
13RDEPEND=""
14# sys-apps/shadow is needed for useradd, etc, bug #94745.
15 19
16DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
17 21
18# Wait for the supplied number of seconds. If no argument is supplied, defaults 22if has "${EAPI:-0}" 0 1 2; then
19# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 23
20# outputting to a terminal, don't wait. For compatability purposes, the argument 24# @FUNCTION: epause
21# must be an integer greater than zero. 25# @USAGE: [seconds]
22# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 26# @DESCRIPTION:
27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
28# printing a message the user should probably be reading and often used in
29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
30# don't wait at all. Defined in EAPIs 0 1 and 2.
23epause() { 31epause() {
24 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
25 sleep ${1:-5}
26 fi
27} 33}
28 34
29# Beep the specified number of times (defaults to five). If our output 35# @FUNCTION: ebeep
30# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 36# @USAGE: [number of beeps]
31# don't beep. 37# @DESCRIPTION:
32# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 38# Issue the specified number of beeps (default of 5 beeps). Useful when
39# printing a message the user should probably be reading and often used in
40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
41# don't beep at all. Defined in EAPIs 0 1 and 2.
33ebeep() { 42ebeep() {
34 local n 43 local n
35 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
36 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
37 echo -ne "\a" 46 echo -ne "\a"
38 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 47 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
39 echo -ne "\a" 48 echo -ne "\a"
40 sleep 1 49 sleep 1
41 done 50 done
42 fi 51 fi
43} 52}
44 53
45# This function generate linker scripts in /usr/lib for dynamic 54else
46# libs in /lib. This is to fix linking problems when you have
47# the .so in /lib, and the .a in /usr/lib. What happens is that
48# in some cases when linking dynamic, the .a in /usr/lib is used
49# instead of the .so in /lib due to gcc/libtool tweaking ld's
50# library search path. This cause many builds to fail.
51# See bug #4411 for more info.
52#
53# To use, simply call:
54#
55# gen_usr_ldscript libfoo.so
56#
57# Note that you should in general use the unversioned name of
58# the library, as ldconfig should usually update it correctly
59# to point to the latest version of the library present.
60#
61# <azarah@gentoo.org> (26 Oct 2002)
62#
63gen_usr_ldscript() {
64 local lib libdir=$(get_libdir)
65 # Just make sure it exists
66 dodir /usr/${libdir}
67 55
68 for lib in "${@}" ; do 56ebeep() {
69 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT 57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
70 /* GNU ld script 58}
71 Since Gentoo has critical dynamic libraries
72 in /lib, and the static versions in /usr/lib,
73 we need to have a "fake" dynamic lib in /usr/lib,
74 otherwise we run into linking problems.
75 59
76 See bug http://bugs.gentoo.org/4411 for more info. 60epause() {
77 */ 61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
78 GROUP ( /${libdir}/${lib} ) 62}
79 END_LDSCRIPT 63
80 fperms a+x "/usr/${libdir}/${lib}" || die "could not change perms on ${lib}" 64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
70# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
71# profile.
72if ! declare -F eqawarn >/dev/null ; then
73 eqawarn() {
74 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
75 }
76fi
77
78# @FUNCTION: ecvs_clean
79# @USAGE: [list of dirs]
80# @DESCRIPTION:
81# Remove CVS directories recursiveley. Useful when a source tarball contains
82# internal CVS directories. Defaults to $PWD.
83ecvs_clean() {
84 [[ -z $* ]] && set -- .
85 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
86 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
87}
88
89# @FUNCTION: esvn_clean
90# @USAGE: [list of dirs]
91# @DESCRIPTION:
92# Remove .svn directories recursiveley. Useful when a source tarball contains
93# internal Subversion directories. Defaults to $PWD.
94esvn_clean() {
95 [[ -z $* ]] && set -- .
96 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
97}
98
99# @FUNCTION: eshopts_push
100# @USAGE: [options to `set` or `shopt`]
101# @DESCRIPTION:
102# Often times code will want to enable a shell option to change code behavior.
103# Since changing shell options can easily break other pieces of code (which
104# assume the default state), eshopts_push is used to (1) push the current shell
105# options onto a stack and (2) pass the specified arguments to set.
106#
107# If the first argument is '-s' or '-u', we assume you want to call `shopt`
108# rather than `set` as there are some options only available via that.
109#
110# A common example is to disable shell globbing so that special meaning/care
111# may be used with variables/arguments to custom functions. That would be:
112# @CODE
113# eshopts_push -o noglob
114# for x in ${foo} ; do
115# if ...some check... ; then
116# eshopts_pop
117# return 0
118# fi
81 done 119# done
120# eshopts_pop
121# @CODE
122eshopts_push() {
123 # have to assume __ESHOPTS_SAVE__ isn't screwed with
124 # as a `declare -a` here will reset its value
125 local i=${#__ESHOPTS_SAVE__[@]}
126 if [[ $1 == -[su] ]] ; then
127 __ESHOPTS_SAVE__[$i]=$(shopt -p)
128 [[ $# -eq 0 ]] && return 0
129 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
130 else
131 __ESHOPTS_SAVE__[$i]=$-
132 [[ $# -eq 0 ]] && return 0
133 set "$@" || die "eshopts_push: bad options to set: $*"
134 fi
82} 135}
83 136
137# @FUNCTION: eshopts_pop
138# @USAGE:
139# @DESCRIPTION:
140# Restore the shell options to the state saved with the corresponding
141# eshopts_push call. See that function for more details.
142eshopts_pop() {
143 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
144 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
145 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
146 local s=${__ESHOPTS_SAVE__[$i]}
147 unset __ESHOPTS_SAVE__[$i]
148 if [[ ${s} == "shopt -"* ]] ; then
149 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
150 else
151 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
152 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
153 fi
154}
84 155
85# Default directory where patches are located 156# @VARIABLE: EPATCH_SOURCE
157# @DESCRIPTION:
158# Default directory to search for patches.
86EPATCH_SOURCE="${WORKDIR}/patch" 159EPATCH_SOURCE="${WORKDIR}/patch"
87# Default extension for patches 160# @VARIABLE: EPATCH_SUFFIX
161# @DESCRIPTION:
162# Default extension for patches (do not prefix the period yourself).
88EPATCH_SUFFIX="patch.bz2" 163EPATCH_SUFFIX="patch.bz2"
164# @VARIABLE: EPATCH_OPTS
165# @DESCRIPTION:
89# Default options for patch 166# Default options for patch:
167# @CODE
90# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 168# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
91# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 169# --no-backup-if-mismatch - do not leave .orig files behind
92# Set -E to automatically remove empty files. 170# -E - automatically remove empty files
171# @CODE
93EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 172EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
173# @VARIABLE: EPATCH_EXCLUDE
174# @DESCRIPTION:
94# List of patches not to apply. Not this is only file names, 175# List of patches not to apply. Note this is only file names,
95# and not the full path .. 176# and not the full path. Globs accepted.
96EPATCH_EXCLUDE="" 177EPATCH_EXCLUDE=""
178# @VARIABLE: EPATCH_SINGLE_MSG
179# @DESCRIPTION:
97# Change the printed message for a single patch. 180# Change the printed message for a single patch.
98EPATCH_SINGLE_MSG="" 181EPATCH_SINGLE_MSG=""
182# @VARIABLE: EPATCH_MULTI_MSG
183# @DESCRIPTION:
99# Change the printed message for multiple patches. 184# Change the printed message for multiple patches.
100EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 185EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
101# Force applying bulk patches even if not following the style: 186# @VARIABLE: EPATCH_FORCE
102# 187# @DESCRIPTION:
103# ??_${ARCH}_foo.${EPATCH_SUFFIX} 188# Only require patches to match EPATCH_SUFFIX rather than the extended
104# 189# arch naming style.
105EPATCH_FORCE="no" 190EPATCH_FORCE="no"
106 191
107# This function is for bulk patching, or in theory for just one 192# @FUNCTION: epatch
108# or two patches. 193# @USAGE: [patches] [dirs of patches]
194# @DESCRIPTION:
195# epatch is designed to greatly simplify the application of patches. It can
196# process patch files directly, or directories of patches. The patches may be
197# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
198# the -p option as epatch will automatically attempt -p0 to -p5 until things
199# apply successfully.
109# 200#
110# It should work with .bz2, .gz, .zip and plain text patches. 201# If you do not specify any options, then epatch will default to the directory
111# Currently all patches should be the same format. 202# specified by EPATCH_SOURCE.
112# 203#
113# You do not have to specify '-p' option to patch, as it will 204# When processing directories, epatch will apply all patches that match:
114# try with -p0 to -p5 until it succeed, or fail at -p5. 205# @CODE
115# 206# if ${EPATCH_FORCE} != "yes"
116# Above EPATCH_* variables can be used to control various defaults,
117# bug they should be left as is to ensure an ebuild can rely on
118# them for.
119#
120# Patches are applied in current directory.
121#
122# Bulk Patches should preferibly have the form of:
123#
124# ??_${ARCH}_foo.${EPATCH_SUFFIX} 207# ??_${ARCH}_foo.${EPATCH_SUFFIX}
208# else
209# *.${EPATCH_SUFFIX}
210# @CODE
211# The leading ?? are typically numbers used to force consistent patch ordering.
212# The arch field is used to apply patches only for the host architecture with
213# the special value of "all" means apply for everyone. Note that using values
214# other than "all" is highly discouraged -- you should apply patches all the
215# time and let architecture details be detected at configure/compile time.
125# 216#
126# For example: 217# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
218# for patches to apply.
127# 219#
128# 01_all_misc-fix.patch.bz2 220# Refer to the other EPATCH_xxx variables for more customization of behavior.
129# 02_sparc_another-fix.patch.bz2
130#
131# This ensures that there are a set order, and you can have ARCH
132# specific patches.
133#
134# If you however give an argument to epatch(), it will treat it as a
135# single patch that need to be applied if its a file. If on the other
136# hand its a directory, it will set EPATCH_SOURCE to this.
137#
138# <azarah@gentoo.org> (10 Nov 2002)
139#
140epatch() { 221epatch() {
141 _epatch_draw_line() { 222 _epatch_draw_line() {
223 # create a line of same length as input string
142 [[ -z $1 ]] && set "$(printf "%65s" '')" 224 [[ -z $1 ]] && set "$(printf "%65s" '')"
143 echo "${1//?/=}" 225 echo "${1//?/=}"
144 } 226 }
145 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
146 local PIPE_CMD=""
147 local STDERR_TARGET="${T}/$$.out"
148 local PATCH_TARGET="${T}/$$.patch"
149 local PATCH_SUFFIX=""
150 local SINGLE_PATCH="no"
151 local x=""
152 227
153 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 228 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
154 229
155 if [ "$#" -gt 1 ] 230 # Let the rest of the code process one user arg at a time --
156 then 231 # each arg may expand into multiple patches, and each arg may
232 # need to start off with the default global EPATCH_xxx values
233 if [[ $# -gt 1 ]] ; then
157 local m="" 234 local m
158 for m in "$@" ; do 235 for m in "$@" ; do
159 epatch "${m}" 236 epatch "${m}"
160 done 237 done
161 return 0 238 return 0
162 fi 239 fi
163 240
164 if [ -n "$1" -a -f "$1" ] 241 local SINGLE_PATCH="no"
165 then 242 # no args means process ${EPATCH_SOURCE}
243 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
244
245 if [[ -f $1 ]] ; then
166 SINGLE_PATCH="yes" 246 SINGLE_PATCH="yes"
167 247 set -- "$1"
168 local EPATCH_SOURCE="$1" 248 # Use the suffix from the single patch (localize it); the code
249 # below will find the suffix for us
169 local EPATCH_SUFFIX="${1##*\.}" 250 local EPATCH_SUFFIX=$1
170 251
171 elif [ -n "$1" -a -d "$1" ] 252 elif [[ -d $1 ]] ; then
172 then 253 # Some people like to make dirs of patches w/out suffixes (vim)
173 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 254 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
174 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 255
256 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
257 # Re-use EPATCH_SOURCE as a search dir
258 epatch "${EPATCH_SOURCE}/$1"
259 return $?
260
261 else
262 # sanity check ... if it isn't a dir or file, wtf man ?
263 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
264 echo
265 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
266 eerror
267 eerror " ${EPATCH_SOURCE}"
268 eerror " ( ${EPATCH_SOURCE##*/} )"
269 echo
270 die "Cannot find \$EPATCH_SOURCE!"
271 fi
272
273 local PIPE_CMD
274 case ${EPATCH_SUFFIX##*\.} in
275 xz) PIPE_CMD="xz -dc" ;;
276 lzma) PIPE_CMD="lzma -dc" ;;
277 bz2) PIPE_CMD="bzip2 -dc" ;;
278 gz|Z|z) PIPE_CMD="gzip -dc" ;;
279 ZIP|zip) PIPE_CMD="unzip -p" ;;
280 *) ;;
281 esac
282
283 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
284
285 local x
286 for x in "$@" ; do
287 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
288 # didn't match anything, ignore continue on
289 [[ ! -f ${x} ]] && continue
290
291 local patchname=${x##*/}
292
293 # Apply single patches, or forced sets of patches, or
294 # patches with ARCH dependant names.
295 # ???_arch_foo.patch
296 # Else, skip this input altogether
297 local a=${patchname#*_} # strip the ???_
298 a=${a%%_*} # strip the _foo.patch
299 if ! [[ ${SINGLE_PATCH} == "yes" || \
300 ${EPATCH_FORCE} == "yes" || \
301 ${a} == all || \
302 ${a} == ${ARCH} ]]
175 then 303 then
176 local EPATCH_SOURCE="$1/*" 304 continue
305 fi
306
307 # Let people filter things dynamically
308 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
309 # let people use globs in the exclude
310 eshopts_push -o noglob
311
312 local ex
313 for ex in ${EPATCH_EXCLUDE} ; do
314 if [[ ${patchname} == ${ex} ]] ; then
315 eshopts_pop
316 continue 2
317 fi
318 done
319
320 eshopts_pop
321 fi
322
323 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
324 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
325 einfo "${EPATCH_SINGLE_MSG}"
326 else
327 einfo "Applying ${patchname} ..."
328 fi
177 else 329 else
178 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 330 einfo " ${patchname} ..."
179 fi 331 fi
180 else 332
181 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 333 # most of the time, there will only be one run per unique name,
182 then 334 # but if there are more, make sure we get unique log filenames
183 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 335 local STDERR_TARGET="${T}/${patchname}.out"
184 then 336 if [[ -e ${STDERR_TARGET} ]] ; then
185 EPATCH_SOURCE="$1" 337 STDERR_TARGET="${T}/${patchname}-$$.out"
338 fi
339
340 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
341
342 # Decompress the patch if need be
343 local count=0
344 local PATCH_TARGET
345 if [[ -n ${PIPE_CMD} ]] ; then
346 PATCH_TARGET="${T}/$$.patch"
347 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
348
349 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
350 echo
351 eerror "Could not extract patch!"
352 #die "Could not extract patch!"
353 count=5
354 break
186 fi 355 fi
356 else
357 PATCH_TARGET=${x}
358 fi
187 359
360 # Check for absolute paths in patches. If sandbox is disabled,
361 # people could (accidently) patch files in the root filesystem.
362 # Or trigger other unpleasantries #237667. So disallow -p0 on
363 # such patches.
364 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
365 if [[ -n ${abs_paths} ]] ; then
366 count=1
367 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
368 fi
369 # Similar reason, but with relative paths.
370 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
371 if [[ -n ${rel_paths} ]] ; then
372 eqawarn "QA Notice: Your patch uses relative paths '../'."
373 eqawarn " In the future this will cause a failure."
374 eqawarn "${rel_paths}"
375 fi
376
377 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
378 while [[ ${count} -lt 5 ]] ; do
379 # Generate some useful debug info ...
380 (
381 _epatch_draw_line "***** ${patchname} *****"
188 echo 382 echo
189 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 383 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
384 echo
385 _epatch_draw_line "***** ${patchname} *****"
386 patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}" 2>&1
387 ret=$?
388 echo
389 echo "patch program exited with status ${ret}"
390 exit ${ret}
391 ) >> "${STDERR_TARGET}"
392
393 if [ $? -eq 0 ] ; then
394 (
395 _epatch_draw_line "***** ${patchname} *****"
396 echo
397 echo "ACTUALLY APPLYING ${patchname} ..."
398 echo
399 _epatch_draw_line "***** ${patchname} *****"
400 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
401 ret=$?
402 echo
403 echo "patch program exited with status ${ret}"
404 exit ${ret}
405 ) >> "${STDERR_TARGET}"
406
407 if [ $? -ne 0 ] ; then
408 echo
409 eerror "A dry-run of patch command succeeded, but actually"
410 eerror "applying the patch failed!"
411 #die "Real world sux compared to the dreamworld!"
412 count=5
413 fi
414 break
415 fi
416
417 : $(( count++ ))
418 done
419
420 # if we had to decompress the patch, delete the temp one
421 if [[ -n ${PIPE_CMD} ]] ; then
422 rm -f "${PATCH_TARGET}"
423 fi
424
425 if [[ ${count} -ge 5 ]] ; then
426 echo
427 eerror "Failed Patch: ${patchname} !"
428 eerror " ( ${PATCH_TARGET} )"
190 eerror 429 eerror
191 eerror " ${EPATCH_SOURCE}" 430 eerror "Include in your bugreport the contents of:"
192 eerror " ( ${EPATCH_SOURCE##*/} )" 431 eerror
432 eerror " ${STDERR_TARGET}"
193 echo 433 echo
194 die "Cannot find \$EPATCH_SOURCE!"
195 fi
196
197 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
198 fi
199
200 case ${EPATCH_SUFFIX##*\.} in
201 bz2)
202 PIPE_CMD="bzip2 -dc"
203 PATCH_SUFFIX="bz2"
204 ;;
205 gz|Z|z)
206 PIPE_CMD="gzip -dc"
207 PATCH_SUFFIX="gz"
208 ;;
209 ZIP|zip)
210 PIPE_CMD="unzip -p"
211 PATCH_SUFFIX="zip"
212 ;;
213 *)
214 PIPE_CMD="cat"
215 PATCH_SUFFIX="patch"
216 ;;
217 esac
218
219 if [ "${SINGLE_PATCH}" = "no" ]
220 then
221 einfo "${EPATCH_MULTI_MSG}"
222 fi
223 for x in ${EPATCH_SOURCE}
224 do
225 # New ARCH dependant patch naming scheme ...
226 #
227 # ???_arch_foo.patch
228 #
229 if [ -f ${x} ] && \
230 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
231 [ "${EPATCH_FORCE}" = "yes" ])
232 then
233 local count=0
234 local popts="${EPATCH_OPTS}"
235 local patchname=${x##*/}
236
237 if [ -n "${EPATCH_EXCLUDE}" ]
238 then
239 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
240 then
241 continue
242 fi
243 fi
244
245 if [ "${SINGLE_PATCH}" = "yes" ]
246 then
247 if [ -n "${EPATCH_SINGLE_MSG}" ]
248 then
249 einfo "${EPATCH_SINGLE_MSG}"
250 else
251 einfo "Applying ${patchname} ..."
252 fi
253 else
254 einfo " ${patchname} ..."
255 fi
256
257 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
258 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
259
260 # Allow for prefix to differ ... im lazy, so shoot me :/
261 while [ "${count}" -lt 5 ]
262 do
263 # Generate some useful debug info ...
264 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
266
267 if [ "${PATCH_SUFFIX}" != "patch" ]
268 then
269 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
270 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
271 else
272 PATCH_TARGET="${x}"
273 fi
274
275 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
276 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
277
278 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
279 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
280
281 if [ "${PATCH_SUFFIX}" != "patch" ]
282 then
283 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
284 then
285 echo
286 eerror "Could not extract patch!"
287 #die "Could not extract patch!"
288 count=5
289 break
290 fi
291 fi
292
293 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
294 then
295 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
296 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
297 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
298 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
299 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
300
301 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
302 _epatch_assert
303
304 if [ "$?" -ne 0 ]
305 then
306 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
307 echo
308 eerror "A dry-run of patch command succeeded, but actually"
309 eerror "applying the patch failed!"
310 #die "Real world sux compared to the dreamworld!"
311 count=5
312 fi
313
314 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
315
316 break
317 fi
318
319 count=$((count + 1))
320 done
321
322 if [ "${PATCH_SUFFIX}" != "patch" ]
323 then
324 rm -f ${PATCH_TARGET}
325 fi
326
327 if [ "${count}" -eq 5 ]
328 then
329 echo
330 eerror "Failed Patch: ${patchname} !"
331 eerror " ( ${PATCH_TARGET} )"
332 eerror
333 eerror "Include in your bugreport the contents of:"
334 eerror
335 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
336 echo
337 die "Failed Patch: ${patchname}!" 434 die "Failed Patch: ${patchname}!"
338 fi 435 fi
339 436
340 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 437 # if everything worked, delete the patch log
341 438 rm -f "${STDERR_TARGET}"
342 eend 0 439 eend 0
343 fi
344 done 440 done
345 if [ "${SINGLE_PATCH}" = "no" ] 441
346 then 442 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
347 einfo "Done with patching" 443 : # everything worked
444}
445
446# @FUNCTION: epatch_user
447# @USAGE:
448# @DESCRIPTION:
449# Applies user-provided patches to the source tree. The patches are
450# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
451# of these three directories to exist will be the one to use, ignoring
452# any more general directories which might exist as well.
453#
454# User patches are intended for quick testing of patches without ebuild
455# modifications, as well as for permanent customizations a user might
456# desire. Obviously, there can be no official support for arbitrarily
457# patched ebuilds. So whenever a build log in a bug report mentions that
458# user patches were applied, the user should be asked to reproduce the
459# problem without these.
460#
461# Not all ebuilds do call this function, so placing patches in the
462# stated directory might or might not work, depending on the package and
463# the eclasses it inherits and uses. It is safe to call the function
464# repeatedly, so it is always possible to add a call at the ebuild
465# level. The first call is the time when the patches will be
466# applied.
467#
468# Ideally, this function should be called after gentoo-specific patches
469# have been applied, so that their code can be modified as well, but
470# before calls to e.g. eautoreconf, as the user patches might affect
471# autotool input files as well.
472epatch_user() {
473 [[ $# -ne 0 ]] && die "epatch_user takes no options"
474
475 # Allow multiple calls to this function; ignore all but the first
476 local applied="${T}/epatch_user.applied"
477 [[ -e ${applied} ]] && return 2
478
479 # don't clobber any EPATCH vars that the parent might want
480 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
481 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
482 EPATCH_SOURCE=${base}/${CTARGET}/${check}
483 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
484 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
485 if [[ -d ${EPATCH_SOURCE} ]] ; then
486 EPATCH_SOURCE=${EPATCH_SOURCE} \
487 EPATCH_SUFFIX="patch" \
488 EPATCH_FORCE="yes" \
489 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
490 epatch
491 echo "${EPATCH_SOURCE}" > "${applied}"
492 return 0
348 fi 493 fi
494 done
495 echo "none" > "${applied}"
496 return 1
349} 497}
350 498
499# @FUNCTION: emktemp
500# @USAGE: [temp dir]
501# @DESCRIPTION:
351# Cheap replacement for when debianutils (and thus mktemp) 502# Cheap replacement for when debianutils (and thus mktemp)
352# does not exist on the users system 503# does not exist on the users system.
353# vapier@gentoo.org
354#
355# Takes just 1 optional parameter (the directory to create tmpfile in)
356emktemp() { 504emktemp() {
357 local exe="touch" 505 local exe="touch"
358 [[ $1 == -d ]] && exe="mkdir" && shift 506 [[ $1 == -d ]] && exe="mkdir" && shift
359 local topdir=$1 507 local topdir=$1
360 508
362 [[ -z ${T} ]] \ 510 [[ -z ${T} ]] \
363 && topdir="/tmp" \ 511 && topdir="/tmp" \
364 || topdir=${T} 512 || topdir=${T}
365 fi 513 fi
366 514
367 if [[ -z $(type -p mktemp) ]] ; then 515 if ! type -P mktemp > /dev/null ; then
516 # system lacks `mktemp` so we have to fake it
368 local tmp=/ 517 local tmp=/
369 while [[ -e ${tmp} ]] ; do 518 while [[ -e ${tmp} ]] ; do
370 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM} 519 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
371 done 520 done
372 ${exe} "${tmp}" || ${exe} -p "${tmp}" 521 ${exe} "${tmp}" || ${exe} -p "${tmp}"
373 echo "${tmp}" 522 echo "${tmp}"
374 else 523 else
524 # the args here will give slightly wierd names on BSD,
525 # but should produce a usable file on all userlands
375 if [[ ${exe} == "touch" ]] ; then 526 if [[ ${exe} == "touch" ]] ; then
376 [[ ${USERLAND} == "GNU" ]] \
377 && mktemp -p "${topdir}" \
378 || TMPDIR="${topdir}" mktemp -t tmp 527 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
379 else 528 else
380 [[ ${USERLAND} == "GNU" ]] \
381 && mktemp -d "${topdir}" \
382 || TMPDIR="${topdir}" mktemp -dt tmp 529 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
383 fi
384 fi
385}
386
387# Small wrapper for getent (Linux), nidump (Mac OS X),
388# and pw (FreeBSD) used in enewuser()/enewgroup()
389# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
390# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
391#
392# egetent(database, key)
393egetent() {
394 case ${CHOST} in
395 *-darwin*)
396 case "$2" in
397 *[!0-9]*) # Non numeric
398 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
399 ;;
400 *) # Numeric
401 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
402 ;;
403 esac
404 ;;
405 *-freebsd*|*-dragonfly*)
406 local opts action="user"
407 [[ $1 == "passwd" ]] || action="group"
408
409 # lookup by uid/gid
410 if [[ $2 == [[:digit:]]* ]] ; then
411 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
412 fi
413
414 pw show ${action} ${opts} "$2" -q
415 ;;
416 *-netbsd*|*-openbsd*)
417 grep "$2:\*:" /etc/$1
418 ;;
419 *)
420 type -p nscd >& /dev/null && nscd -i "$1"
421 getent "$1" "$2"
422 ;;
423 esac
424}
425
426# Simplify/standardize adding users to the system
427# vapier@gentoo.org
428#
429# enewuser(username, uid, shell, homedir, groups, extra options)
430#
431# Default values if you do not specify any:
432# username: REQUIRED !
433# uid: next available (see useradd(8))
434# note: pass -1 to get default behavior
435# shell: /bin/false
436# homedir: /dev/null
437# groups: none
438# extra: comment of 'added by portage for ${PN}'
439enewuser() {
440 case ${EBUILD_PHASE} in
441 unpack|compile|test|install)
442 eerror "'enewuser()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
443 eerror "Package fails at QA and at life. Please file a bug."
444 die "Bad package! enewuser is only for use in pkg_* functions!"
445 esac
446
447 # get the username
448 local euser=$1; shift
449 if [[ -z ${euser} ]] ; then
450 eerror "No username specified !"
451 die "Cannot call enewuser without a username"
452 fi
453
454 # lets see if the username already exists
455 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
456 return 0
457 fi
458 einfo "Adding user '${euser}' to your system ..."
459
460 # options to pass to useradd
461 local opts=
462
463 # handle uid
464 local euid=$1; shift
465 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
466 if [[ ${euid} -gt 0 ]] ; then
467 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
468 euid="next"
469 fi 530 fi
470 else
471 eerror "Userid given but is not greater than 0 !"
472 die "${euid} is not a valid UID"
473 fi 531 fi
474 else
475 euid="next"
476 fi
477 if [[ ${euid} == "next" ]] ; then
478 for euid in $(seq 101 999) ; do
479 [[ -z $(egetent passwd ${euid}) ]] && break
480 done
481 fi
482 opts="${opts} -u ${euid}"
483 einfo " - Userid: ${euid}"
484
485 # handle shell
486 local eshell=$1; shift
487 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
488 if [[ ! -e ${ROOT}${eshell} ]] ; then
489 eerror "A shell was specified but it does not exist !"
490 die "${eshell} does not exist in ${ROOT}"
491 fi
492 if [[ ${eshell} == */false || ${eshell} == */nologin ]] ; then
493 eerror "Do not specify ${eshell} yourself, use -1"
494 die "Pass '-1' as the shell parameter"
495 fi
496 else
497 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
498 [[ -x ${ROOT}${shell} ]] && break
499 done
500
501 if [[ ${shell} == "/dev/null" ]] ; then
502 eerror "Unable to identify the shell to use"
503 die "Unable to identify the shell to use"
504 fi
505
506 eshell=${shell}
507 fi
508 einfo " - Shell: ${eshell}"
509 opts="${opts} -s ${eshell}"
510
511 # handle homedir
512 local ehome=$1; shift
513 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
514 ehome="/dev/null"
515 fi
516 einfo " - Home: ${ehome}"
517 opts="${opts} -d ${ehome}"
518
519 # handle groups
520 local egroups=$1; shift
521 if [[ ! -z ${egroups} ]] ; then
522 local oldifs=${IFS}
523 local defgroup="" exgroups=""
524
525 export IFS=","
526 for g in ${egroups} ; do
527 export IFS=${oldifs}
528 if [[ -z $(egetent group "${g}") ]] ; then
529 eerror "You must add group ${g} to the system first"
530 die "${g} is not a valid GID"
531 fi
532 if [[ -z ${defgroup} ]] ; then
533 defgroup=${g}
534 else
535 exgroups="${exgroups},${g}"
536 fi
537 export IFS=","
538 done
539 export IFS=${oldifs}
540
541 opts="${opts} -g ${defgroup}"
542 if [[ ! -z ${exgroups} ]] ; then
543 opts="${opts} -G ${exgroups:1}"
544 fi
545 else
546 egroups="(none)"
547 fi
548 einfo " - Groups: ${egroups}"
549
550 # handle extra and add the user
551 local oldsandbox=${SANDBOX_ON}
552 export SANDBOX_ON="0"
553 case ${CHOST} in
554 *-darwin*)
555 ### Make the user
556 if [[ -z $@ ]] ; then
557 dscl . create /users/${euser} uid ${euid}
558 dscl . create /users/${euser} shell ${eshell}
559 dscl . create /users/${euser} home ${ehome}
560 dscl . create /users/${euser} realname "added by portage for ${PN}"
561 ### Add the user to the groups specified
562 local oldifs=${IFS}
563 export IFS=","
564 for g in ${egroups} ; do
565 dscl . merge /groups/${g} users ${euser}
566 done
567 export IFS=${oldifs}
568 else
569 einfo "Extra options are not supported on Darwin yet"
570 einfo "Please report the ebuild along with the info below"
571 einfo "eextra: $@"
572 die "Required function missing"
573 fi
574 ;;
575 *-freebsd*|*-dragonfly*)
576 if [[ -z $@ ]] ; then
577 pw useradd ${euser} ${opts} \
578 -c "added by portage for ${PN}" \
579 die "enewuser failed"
580 else
581 einfo " - Extra: $@"
582 pw useradd ${euser} ${opts} \
583 "$@" || die "enewuser failed"
584 fi
585 ;;
586
587 *-netbsd*)
588 if [[ -z $@ ]] ; then
589 useradd ${opts} ${euser} || die "enewuser failed"
590 else
591 einfo " - Extra: $@"
592 useradd ${opts} ${euser} "$@" || die "enewuser failed"
593 fi
594 ;;
595
596 *-openbsd*)
597 if [[ -z $@ ]] ; then
598 useradd -u ${euid} -s ${eshell} \
599 -d ${ehome} -c "Added by portage for ${PN}" \
600 -g ${egroups} ${euser} || die "enewuser failed"
601 else
602 einfo " - Extra: $@"
603 useradd -u ${euid} -s ${eshell} \
604 -d ${ehome} -c "Added by portage for ${PN}" \
605 -g ${egroups} ${euser} "$@" || die "enewuser failed"
606 fi
607 ;;
608
609 *)
610 if [[ -z $@ ]] ; then
611 useradd ${opts} ${euser} \
612 -c "added by portage for ${PN}" \
613 || die "enewuser failed"
614 else
615 einfo " - Extra: $@"
616 useradd ${opts} ${euser} "$@" \
617 || die "enewuser failed"
618 fi
619 ;;
620 esac
621
622 if [[ ! -e ${ROOT}/${ehome} ]] ; then
623 einfo " - Creating ${ehome} in ${ROOT}"
624 mkdir -p "${ROOT}/${ehome}"
625 chown ${euser} "${ROOT}/${ehome}"
626 chmod 755 "${ROOT}/${ehome}"
627 fi
628
629 export SANDBOX_ON=${oldsandbox}
630} 532}
631 533
632# Simplify/standardize adding groups to the system 534# @FUNCTION: edos2unix
633# vapier@gentoo.org 535# @USAGE: <file> [more files ...]
634# 536# @DESCRIPTION:
635# enewgroup(group, gid) 537# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
636# 538# to remove all of these text utilities from DEPEND variables because this
637# Default values if you do not specify any: 539# is a script based solution. Just give it a list of files to convert and
638# groupname: REQUIRED ! 540# they will all be changed from the DOS CRLF format to the UNIX LF format.
639# gid: next available (see groupadd(8))
640# extra: none
641enewgroup() {
642 case ${EBUILD_PHASE} in
643 unpack|compile|test|install)
644 eerror "'enewgroup()' called from '${EBUILD_PHASE}()' which is not a pkg_* function."
645 eerror "Package fails at QA and at life. Please file a bug."
646 die "Bad package! enewgroup is only for use in pkg_* functions!"
647 esac
648
649 # get the group
650 local egroup="$1"; shift
651 if [ -z "${egroup}" ]
652 then
653 eerror "No group specified !"
654 die "Cannot call enewgroup without a group"
655 fi
656
657 # see if group already exists
658 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
659 then
660 return 0
661 fi
662 einfo "Adding group '${egroup}' to your system ..."
663
664 # options to pass to useradd
665 local opts=
666
667 # handle gid
668 local egid="$1"; shift
669 if [ ! -z "${egid}" ]
670 then
671 if [ "${egid}" -gt 0 ]
672 then
673 if [ -z "`egetent group ${egid}`" ]
674 then
675 if [[ "${CHOST}" == *-darwin* ]]; then
676 opts="${opts} ${egid}"
677 else
678 opts="${opts} -g ${egid}"
679 fi
680 else
681 egid="next available; requested gid taken"
682 fi
683 else
684 eerror "Groupid given but is not greater than 0 !"
685 die "${egid} is not a valid GID"
686 fi
687 else
688 egid="next available"
689 fi
690 einfo " - Groupid: ${egid}"
691
692 # handle extra
693 local eextra="$@"
694 opts="${opts} ${eextra}"
695
696 # add the group
697 local oldsandbox="${SANDBOX_ON}"
698 export SANDBOX_ON="0"
699 case ${CHOST} in
700 *-darwin*)
701 if [ ! -z "${eextra}" ];
702 then
703 einfo "Extra options are not supported on Darwin/OS X yet"
704 einfo "Please report the ebuild along with the info below"
705 einfo "eextra: ${eextra}"
706 die "Required function missing"
707 fi
708
709 # If we need the next available
710 case ${egid} in
711 *[!0-9]*) # Non numeric
712 for egid in $(seq 101 999); do
713 [ -z "`egetent group ${egid}`" ] && break
714 done
715 esac
716 dscl . create /groups/${egroup} gid ${egid}
717 dscl . create /groups/${egroup} passwd '*'
718 ;;
719
720 *-freebsd*|*-dragonfly*)
721 case ${egid} in
722 *[!0-9]*) # Non numeric
723 for egid in $(seq 101 999); do
724 [ -z "`egetent group ${egid}`" ] && break
725 done
726 esac
727 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
728 ;;
729
730 *-netbsd*)
731 case ${egid} in
732 *[!0-9]*) # Non numeric
733 for egid in $(seq 101 999); do
734 [ -z "`egetent group ${egid}`" ] && break
735 done
736 esac
737 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
738 ;;
739
740 *)
741 groupadd ${opts} ${egroup} || die "enewgroup failed"
742 ;;
743 esac
744 export SANDBOX_ON="${oldsandbox}"
745}
746
747# Simple script to replace 'dos2unix' binaries
748# vapier@gentoo.org
749#
750# edos2unix(file, <more files> ...)
751edos2unix() { 541edos2unix() {
752 for f in "$@" 542 [[ $# -eq 0 ]] && return 0
753 do 543 sed -i 's/\r$//' -- "$@" || die
754 cp "${f}" ${T}/edos2unix
755 sed 's/\r$//' ${T}/edos2unix > "${f}"
756 done
757} 544}
758
759
760##############################################################
761# START: Handle .desktop files and menu entries #
762# maybe this should be separated into a new eclass some time #
763# lanius@gentoo.org #
764##############################################################
765 545
766# Make a desktop file ! 546# Make a desktop file !
767# Great for making those icons in kde/gnome startmenu ! 547# Great for making those icons in kde/gnome startmenu !
768# Amaze your friends ! Get the women ! Join today ! 548# Amaze your friends ! Get the women ! Join today !
769# 549#
770# make_desktop_entry(<binary>, [name], [icon], [type], [path]) 550# make_desktop_entry(<command>, [name], [icon], [type], [fields])
771# 551#
772# binary: what binary does the app run with ? 552# binary: what command does the app run with ?
773# name: the name that will show up in the menu 553# name: the name that will show up in the menu
774# icon: give your little like a pretty little icon ... 554# icon: give your little like a pretty little icon ...
775# this can be relative (to /usr/share/pixmaps) or 555# this can be relative (to /usr/share/pixmaps) or
776# a full path to an icon 556# a full path to an icon
777# type: what kind of application is this ? for categories: 557# type: what kind of application is this ? for categories:
778# http://www.freedesktop.org/Standards/desktop-entry-spec 558# http://standards.freedesktop.org/menu-spec/latest/apa.html
779# path: if your app needs to startup in a specific dir 559# fields: extra fields to append to the desktop file; a printf string
780make_desktop_entry() { 560make_desktop_entry() {
781 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 561 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
782 562
783 local exec=${1} 563 local exec=${1}
784 local name=${2:-${PN}} 564 local name=${2:-${PN}}
785 local icon=${3:-${PN}.png} 565 local icon=${3:-${PN}}
786 local type=${4} 566 local type=${4}
787 local path=${5} 567 local fields=${5}
788 568
789 if [[ -z ${type} ]] ; then 569 if [[ -z ${type} ]] ; then
790 local catmaj=${CATEGORY%%-*} 570 local catmaj=${CATEGORY%%-*}
791 local catmin=${CATEGORY##*-} 571 local catmin=${CATEGORY##*-}
792 case ${catmaj} in 572 case ${catmaj} in
793 app) 573 app)
794 case ${catmin} in 574 case ${catmin} in
575 accessibility) type=Accessibility;;
795 admin) type=System;; 576 admin) type=System;;
577 antivirus) type=System;;
578 arch) type=Archiving;;
579 backup) type=Archiving;;
796 cdr) type=DiscBurning;; 580 cdr) type=DiscBurning;;
797 dicts) type=Dictionary;; 581 dicts) type=Dictionary;;
582 doc) type=Documentation;;
798 editors) type=TextEditor;; 583 editors) type=TextEditor;;
799 emacs) type=TextEditor;; 584 emacs) type=TextEditor;;
800 emulation) type=Emulator;; 585 emulation) type=Emulator;;
801 laptop) type=HardwareSettings;; 586 laptop) type=HardwareSettings;;
802 office) type=Office;; 587 office) type=Office;;
588 pda) type=PDA;;
803 vim) type=TextEditor;; 589 vim) type=TextEditor;;
804 xemacs) type=TextEditor;; 590 xemacs) type=TextEditor;;
805 *) type=;;
806 esac 591 esac
807 ;; 592 ;;
808 593
809 dev) 594 dev)
810 type="Development" 595 type="Development"
811 ;; 596 ;;
812 597
813 games) 598 games)
814 case ${catmin} in 599 case ${catmin} in
815 action) type=ActionGame;; 600 action|fps) type=ActionGame;;
816 arcade) type=ArcadeGame;; 601 arcade) type=ArcadeGame;;
817 board) type=BoardGame;; 602 board) type=BoardGame;;
818 kid) type=KidsGame;;
819 emulation) type=Emulator;; 603 emulation) type=Emulator;;
604 kids) type=KidsGame;;
820 puzzle) type=LogicGame;; 605 puzzle) type=LogicGame;;
606 roguelike) type=RolePlaying;;
821 rpg) type=RolePlaying;; 607 rpg) type=RolePlaying;;
822 roguelike) type=RolePlaying;;
823 simulation) type=Simulation;; 608 simulation) type=Simulation;;
824 sports) type=SportsGame;; 609 sports) type=SportsGame;;
825 strategy) type=StrategyGame;; 610 strategy) type=StrategyGame;;
826 *) type=;;
827 esac 611 esac
828 type="Game;${type}" 612 type="Game;${type}"
829 ;; 613 ;;
830 614
615 gnome)
616 type="Gnome;GTK"
617 ;;
618
619 kde)
620 type="KDE;Qt"
621 ;;
622
831 mail) 623 mail)
832 type="Network;Email" 624 type="Network;Email"
833 ;; 625 ;;
834 626
835 media) 627 media)
836 case ${catmin} in 628 case ${catmin} in
629 gfx)
837 gfx) type=Graphics;; 630 type=Graphics
631 ;;
632 *)
633 case ${catmin} in
838 radio) type=Tuner;; 634 radio) type=Tuner;;
839 sound) type=Audio;; 635 sound) type=Audio;;
840 tv) type=TV;; 636 tv) type=TV;;
841 video) type=Video;; 637 video) type=Video;;
842 *) type=;; 638 esac
639 type="AudioVideo;${type}"
640 ;;
843 esac 641 esac
844 type="AudioVideo;${type}"
845 ;; 642 ;;
846 643
847 net) 644 net)
848 case ${catmin} in 645 case ${catmin} in
849 dialup) type=Dialup;; 646 dialup) type=Dialup;;
852 irc) type=IRCClient;; 649 irc) type=IRCClient;;
853 mail) type=Email;; 650 mail) type=Email;;
854 news) type=News;; 651 news) type=News;;
855 nntp) type=News;; 652 nntp) type=News;;
856 p2p) type=FileTransfer;; 653 p2p) type=FileTransfer;;
857 *) type=;; 654 voip) type=Telephony;;
858 esac 655 esac
859 type="Network;${type}" 656 type="Network;${type}"
860 ;; 657 ;;
861 658
862 sci) 659 sci)
863 case ${catmin} in 660 case ${catmin} in
864 astro*) type=Astronomy;; 661 astro*) type=Astronomy;;
865 bio*) type=Biology;; 662 bio*) type=Biology;;
866 calc*) type=Calculator;; 663 calc*) type=Calculator;;
867 chem*) type=Chemistry;; 664 chem*) type=Chemistry;;
665 elec*) type=Electronics;;
868 geo*) type=Geology;; 666 geo*) type=Geology;;
869 math*) type=Math;; 667 math*) type=Math;;
870 *) type=;; 668 physics) type=Physics;;
669 visual*) type=DataVisualization;;
871 esac 670 esac
872 type="Science;${type}" 671 type="Education;Science;${type}"
672 ;;
673
674 sys)
675 type="System"
873 ;; 676 ;;
874 677
875 www) 678 www)
876 case ${catmin} in 679 case ${catmin} in
877 client) type=WebBrowser;; 680 client) type=WebBrowser;;
878 *) type=;;
879 esac 681 esac
880 type="Network" 682 type="Network;${type}"
881 ;; 683 ;;
882 684
883 *) 685 *)
884 type= 686 type=
885 ;; 687 ;;
888 if [ "${SLOT}" == "0" ] ; then 690 if [ "${SLOT}" == "0" ] ; then
889 local desktop_name="${PN}" 691 local desktop_name="${PN}"
890 else 692 else
891 local desktop_name="${PN}-${SLOT}" 693 local desktop_name="${PN}-${SLOT}"
892 fi 694 fi
893 local desktop=${T}/${exec%% *}-${desktop_name}.desktop 695 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
894# local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 696 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
895 697
698 # Don't append another ";" when a valid category value is provided.
699 type=${type%;}${type:+;}
700
701 eshopts_push -s extglob
702 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
703 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
704 ewarn "allowed in .desktop files if the value is not an absolute path."
705 icon=${icon%.@(xpm|png|svg)}
706 fi
707 eshopts_pop
708
709 cat <<-EOF > "${desktop}"
896echo "[Desktop Entry] 710 [Desktop Entry]
897Encoding=UTF-8
898Version=0.9.2
899Name=${name} 711 Name=${name}
900Type=Application 712 Type=Application
901Comment=${DESCRIPTION} 713 Comment=${DESCRIPTION}
902Exec=${exec} 714 Exec=${exec}
903TryExec=${exec} 715 TryExec=${exec%% *}
904Path=${path}
905Icon=${icon} 716 Icon=${icon}
906Categories=Application;${type};" > "${desktop}" 717 Categories=${type}
718 EOF
719
720 if [[ ${fields:-=} != *=* ]] ; then
721 # 5th arg used to be value to Path=
722 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
723 fields="Path=${fields}"
724 fi
725 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
907 726
908 ( 727 (
909 # wrap the env here so that the 'insinto' call 728 # wrap the env here so that the 'insinto' call
910 # doesn't corrupt the env of the caller 729 # doesn't corrupt the env of the caller
911 insinto /usr/share/applications 730 insinto /usr/share/applications
912 doins "${desktop}" 731 doins "${desktop}"
913 ) 732 ) || die "installing desktop file failed"
914} 733}
915 734
916# Make a GDM/KDM Session file 735# @FUNCTION: validate_desktop_entries
917# 736# @USAGE: [directories]
918# make_desktop_entry(<title>, <command>) 737# @MAINTAINER:
919# title: File to execute to start the Window Manager 738# Carsten Lohrke <carlo@gentoo.org>
920# command: Name of the Window Manager 739# @DESCRIPTION:
740# Validate desktop entries using desktop-file-utils
741validate_desktop_entries() {
742 if [[ -x /usr/bin/desktop-file-validate ]] ; then
743 einfo "Checking desktop entry validity"
744 local directories=""
745 for d in /usr/share/applications $@ ; do
746 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
747 done
748 if [[ -n ${directories} ]] ; then
749 for FILE in $(find ${directories} -name "*\.desktop" \
750 -not -path '*.hidden*' | sort -u 2>/dev/null)
751 do
752 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
753 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
754 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
755 done
756 fi
757 echo ""
758 else
759 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
760 fi
761}
921 762
763# @FUNCTION: make_session_desktop
764# @USAGE: <title> <command> [command args...]
765# @DESCRIPTION:
766# Make a GDM/KDM Session file. The title is the file to execute to start the
767# Window Manager. The command is the name of the Window Manager.
768#
769# You can set the name of the file via the ${wm} variable.
922make_session_desktop() { 770make_session_desktop() {
923 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 771 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
924 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 772 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
925 773
926 local title=$1 774 local title=$1
927 local command=$2 775 local command=$2
928 local desktop=${T}/${wm}.desktop 776 local desktop=${T}/${wm:-${PN}}.desktop
777 shift 2
929 778
779 cat <<-EOF > "${desktop}"
930echo "[Desktop Entry] 780 [Desktop Entry]
931Encoding=UTF-8
932Name=${title} 781 Name=${title}
933Comment=This session logs you into ${title} 782 Comment=This session logs you into ${title}
934Exec=${command} 783 Exec=${command} $*
935TryExec=${command} 784 TryExec=${command}
936Type=Application" > "${desktop}" 785 Type=XSession
786 EOF
937 787
788 (
789 # wrap the env here so that the 'insinto' call
790 # doesn't corrupt the env of the caller
938 insinto /usr/share/xsessions 791 insinto /usr/share/xsessions
939 doins "${desktop}" 792 doins "${desktop}"
793 )
940} 794}
941 795
796# @FUNCTION: domenu
797# @USAGE: <menus>
798# @DESCRIPTION:
799# Install the list of .desktop menu files into the appropriate directory
800# (/usr/share/applications).
942domenu() { 801domenu() {
802 (
803 # wrap the env here so that the 'insinto' call
804 # doesn't corrupt the env of the caller
943 local i j 805 local i j ret=0
944 insinto /usr/share/applications 806 insinto /usr/share/applications
945 for i in "$@" ; do 807 for i in "$@" ; do
946 if [[ -f ${i} ]] ; then 808 if [[ -f ${i} ]] ; then
947 doins "${i}" 809 doins "${i}"
810 ((ret+=$?))
948 elif [[ -d ${i} ]] ; then 811 elif [[ -d ${i} ]] ; then
949 for j in "${i}"/*.desktop ; do 812 for j in "${i}"/*.desktop ; do
950 doins "${j}" 813 doins "${j}"
814 ((ret+=$?))
951 done 815 done
816 else
817 ((++ret))
952 fi 818 fi
953 done 819 done
820 exit ${ret}
821 )
954} 822}
823
824# @FUNCTION: newmenu
825# @USAGE: <menu> <newname>
826# @DESCRIPTION:
827# Like all other new* functions, install the specified menu as newname.
955newmenu() { 828newmenu() {
829 (
830 # wrap the env here so that the 'insinto' call
831 # doesn't corrupt the env of the caller
956 insinto /usr/share/applications 832 insinto /usr/share/applications
957 newins "$1" "$2" 833 newins "$@"
834 )
958} 835}
959 836
837# @FUNCTION: doicon
838# @USAGE: <list of icons>
839# @DESCRIPTION:
840# Install the list of icons into the icon directory (/usr/share/pixmaps).
841# This is useful in conjunction with creating desktop/menu files.
960doicon() { 842doicon() {
843 (
844 # wrap the env here so that the 'insinto' call
845 # doesn't corrupt the env of the caller
961 local i j 846 local i j ret
962 insinto /usr/share/pixmaps 847 insinto /usr/share/pixmaps
963 for i in "$@" ; do 848 for i in "$@" ; do
964 if [[ -f ${i} ]] ; then 849 if [[ -f ${i} ]] ; then
965 doins "${i}" 850 doins "${i}"
851 ((ret+=$?))
966 elif [[ -d ${i} ]] ; then 852 elif [[ -d ${i} ]] ; then
967 for j in "${i}"/*.png ; do 853 for j in "${i}"/*.png ; do
968 doins "${j}" 854 doins "${j}"
855 ((ret+=$?))
969 done 856 done
857 else
858 ((++ret))
970 fi 859 fi
971 done 860 done
861 exit ${ret}
862 )
972} 863}
864
865# @FUNCTION: newicon
866# @USAGE: <icon> <newname>
867# @DESCRIPTION:
868# Like all other new* functions, install the specified icon as newname.
973newicon() { 869newicon() {
870 (
871 # wrap the env here so that the 'insinto' call
872 # doesn't corrupt the env of the caller
974 insinto /usr/share/pixmaps 873 insinto /usr/share/pixmaps
975 newins "$1" "$2" 874 newins "$@"
875 )
976} 876}
977
978##############################################################
979# END: Handle .desktop files and menu entries #
980##############################################################
981
982 877
983# for internal use only (unpack_pdv and unpack_makeself) 878# for internal use only (unpack_pdv and unpack_makeself)
984find_unpackable_file() { 879find_unpackable_file() {
985 local src=$1 880 local src=$1
986 if [[ -z ${src} ]] ; then 881 if [[ -z ${src} ]] ; then
996 fi 891 fi
997 [[ ! -e ${src} ]] && return 1 892 [[ ! -e ${src} ]] && return 1
998 echo "${src}" 893 echo "${src}"
999} 894}
1000 895
896# @FUNCTION: unpack_pdv
897# @USAGE: <file to unpack> <size of off_t>
898# @DESCRIPTION:
1001# Unpack those pesky pdv generated files ... 899# Unpack those pesky pdv generated files ...
1002# They're self-unpacking programs with the binary package stuffed in 900# They're self-unpacking programs with the binary package stuffed in
1003# the middle of the archive. Valve seems to use it a lot ... too bad 901# the middle of the archive. Valve seems to use it a lot ... too bad
1004# it seems to like to segfault a lot :(. So lets take it apart ourselves. 902# it seems to like to segfault a lot :(. So lets take it apart ourselves.
1005# 903#
1006# Usage: unpack_pdv [file to unpack] [size of off_t]
1007# - you have to specify the off_t size ... i have no idea how to extract that 904# You have to specify the off_t size ... I have no idea how to extract that
1008# information out of the binary executable myself. basically you pass in 905# information out of the binary executable myself. Basically you pass in
1009# the size of the off_t type (in bytes) on the machine that built the pdv 906# the size of the off_t type (in bytes) on the machine that built the pdv
907# archive.
908#
1010# archive. one way to determine this is by running the following commands: 909# One way to determine this is by running the following commands:
910#
911# @CODE
1011# strings <pdv archive> | grep lseek 912# strings <pdv archive> | grep lseek
1012# strace -elseek <pdv archive> 913# strace -elseek <pdv archive>
914# @CODE
915#
1013# basically look for the first lseek command (we do the strings/grep because 916# Basically look for the first lseek command (we do the strings/grep because
1014# sometimes the function call is _llseek or something) and steal the 2nd 917# sometimes the function call is _llseek or something) and steal the 2nd
1015# parameter. here is an example: 918# parameter. Here is an example:
919#
920# @CODE
1016# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek 921# vapier@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
1017# lseek 922# lseek
1018# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 923# vapier@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1019# lseek(3, -4, SEEK_END) = 2981250 924# lseek(3, -4, SEEK_END) = 2981250
925# @CODE
926#
1020# thus we would pass in the value of '4' as the second parameter. 927# Thus we would pass in the value of '4' as the second parameter.
1021unpack_pdv() { 928unpack_pdv() {
1022 local src=$(find_unpackable_file $1) 929 local src=$(find_unpackable_file "$1")
1023 local sizeoff_t=$2 930 local sizeoff_t=$2
1024 931
1025 [[ -z ${src} ]] && die "Could not locate source for '$1'" 932 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1026 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :(" 933 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1027 934
1028 local shrtsrc=$(basename "${src}") 935 local shrtsrc=$(basename "${src}")
1029 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 936 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1030 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 937 local metaskip=$(tail -c ${sizeoff_t} "${src}" | hexdump -e \"%i\")
1031 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 938 local tailskip=$(tail -c $((${sizeoff_t}*2)) "${src}" | head -c ${sizeoff_t} | hexdump -e \"%i\")
1032 939
1033 # grab metadata for debug reasons 940 # grab metadata for debug reasons
1034 local metafile="$(emktemp)" 941 local metafile=$(emktemp)
1035 tail -c +$((${metaskip}+1)) ${src} > ${metafile} 942 tail -c +$((${metaskip}+1)) "${src}" > "${metafile}"
1036 943
1037 # rip out the final file name from the metadata 944 # rip out the final file name from the metadata
1038 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`" 945 local datafile=$(tail -c +$((${metaskip}+1)) "${src}" | strings | head -n 1)
1039 datafile="`basename ${datafile}`" 946 datafile=$(basename "${datafile}")
1040 947
1041 # now lets uncompress/untar the file if need be 948 # now lets uncompress/untar the file if need be
1042 local tmpfile="$(emktemp)" 949 local tmpfile=$(emktemp)
1043 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile} 950 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1044 951
1045 local iscompressed="`file -b ${tmpfile}`" 952 local iscompressed=$(file -b "${tmpfile}")
1046 if [ "${iscompressed:0:8}" == "compress" ] ; then 953 if [[ ${iscompressed:0:8} == "compress" ]] ; then
1047 iscompressed=1 954 iscompressed=1
1048 mv ${tmpfile}{,.Z} 955 mv ${tmpfile}{,.Z}
1049 gunzip ${tmpfile} 956 gunzip ${tmpfile}
1050 else 957 else
1051 iscompressed=0 958 iscompressed=0
1052 fi 959 fi
1053 local istar="`file -b ${tmpfile}`" 960 local istar=$(file -b "${tmpfile}")
1054 if [ "${istar:0:9}" == "POSIX tar" ] ; then 961 if [[ ${istar:0:9} == "POSIX tar" ]] ; then
1055 istar=1 962 istar=1
1056 else 963 else
1057 istar=0 964 istar=0
1058 fi 965 fi
1059 966
1087 true 994 true
1088 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 995 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1089 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')" 996 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1090} 997}
1091 998
999# @FUNCTION: unpack_makeself
1000# @USAGE: [file to unpack] [offset] [tail|dd]
1001# @DESCRIPTION:
1092# Unpack those pesky makeself generated files ... 1002# Unpack those pesky makeself generated files ...
1093# They're shell scripts with the binary package tagged onto 1003# They're shell scripts with the binary package tagged onto
1094# the end of the archive. Loki utilized the format as does 1004# the end of the archive. Loki utilized the format as does
1095# many other game companies. 1005# many other game companies.
1096# 1006#
1097# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1007# If the file is not specified, then ${A} is used. If the
1098# - If the file is not specified then unpack will utilize ${A}.
1099# - If the offset is not specified then we will attempt to extract 1008# offset is not specified then we will attempt to extract
1100# the proper offset from the script itself. 1009# the proper offset from the script itself.
1101unpack_makeself() { 1010unpack_makeself() {
1102 local src_input=${1:-${A}} 1011 local src_input=${1:-${A}}
1103 local src=$(find_unpackable_file "${src_input}") 1012 local src=$(find_unpackable_file "${src_input}")
1104 local skip=$2 1013 local skip=$2
1105 local exe=$3 1014 local exe=$3
1107 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1016 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1108 1017
1109 local shrtsrc=$(basename "${src}") 1018 local shrtsrc=$(basename "${src}")
1110 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1019 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1111 if [[ -z ${skip} ]] ; then 1020 if [[ -z ${skip} ]] ; then
1112 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1021 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1113 local skip=0 1022 local skip=0
1114 exe=tail 1023 exe=tail
1115 case ${ver} in 1024 case ${ver} in
1116 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1025 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1117 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1026 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1118 ;; 1027 ;;
1119 2.0|2.0.1) 1028 2.0|2.0.1)
1120 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1029 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1121 ;; 1030 ;;
1122 2.1.1) 1031 2.1.1)
1123 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1032 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1124 let skip="skip + 1" 1033 (( skip++ ))
1125 ;; 1034 ;;
1126 2.1.2) 1035 2.1.2)
1127 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1036 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1128 let skip="skip + 1" 1037 (( skip++ ))
1129 ;; 1038 ;;
1130 2.1.3) 1039 2.1.3)
1131 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1040 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1132 let skip="skip + 1" 1041 (( skip++ ))
1133 ;; 1042 ;;
1134 2.1.4|2.1.5) 1043 2.1.4|2.1.5)
1135 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1044 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1136 skip=$(head -n ${skip} "${src}" | wc -c) 1045 skip=$(head -n ${skip} "${src}" | wc -c)
1137 exe="dd" 1046 exe="dd"
1146 esac 1055 esac
1147 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1056 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1148 fi 1057 fi
1149 case ${exe} in 1058 case ${exe} in
1150 tail) exe="tail -n +${skip} '${src}'";; 1059 tail) exe="tail -n +${skip} '${src}'";;
1151 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1060 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1152 *) die "makeself cant handle exe '${exe}'" 1061 *) die "makeself cant handle exe '${exe}'"
1153 esac 1062 esac
1154 1063
1155 # lets grab the first few bytes of the file to figure out what kind of archive it is 1064 # lets grab the first few bytes of the file to figure out what kind of archive it is
1156 local tmpfile="$(emktemp)" 1065 local filetype tmpfile=$(emktemp)
1157 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}" 1066 eval ${exe} 2>/dev/null | head -c 512 > "${tmpfile}"
1158 local filetype="$(file -b "${tmpfile}")" 1067 filetype=$(file -b "${tmpfile}") || die
1159 case ${filetype} in 1068 case ${filetype} in
1160 *tar\ archive) 1069 *tar\ archive*)
1161 eval ${exe} | tar --no-same-owner -xf - 1070 eval ${exe} | tar --no-same-owner -xf -
1162 ;; 1071 ;;
1163 bzip2*) 1072 bzip2*)
1164 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf - 1073 eval ${exe} | bzip2 -dc | tar --no-same-owner -xf -
1165 ;; 1074 ;;
1175 ;; 1084 ;;
1176 esac 1085 esac
1177 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})" 1086 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1178} 1087}
1179 1088
1089# @FUNCTION: check_license
1090# @USAGE: [license]
1091# @DESCRIPTION:
1180# Display a license for user to accept. 1092# Display a license for user to accept. If no license is
1181#
1182# Usage: check_license [license]
1183# - If the file is not specified then ${LICENSE} is used. 1093# specified, then ${LICENSE} is used.
1184check_license() { 1094check_license() {
1185 local lic=$1 1095 local lic=$1
1186 if [ -z "${lic}" ] ; then 1096 if [ -z "${lic}" ] ; then
1187 lic="${PORTDIR}/licenses/${LICENSE}" 1097 lic="${PORTDIR}/licenses/${LICENSE}"
1188 else 1098 else
1192 lic="${PWD}/${lic}" 1102 lic="${PWD}/${lic}"
1193 elif [ -e "${lic}" ] ; then 1103 elif [ -e "${lic}" ] ; then
1194 lic="${lic}" 1104 lic="${lic}"
1195 fi 1105 fi
1196 fi 1106 fi
1197 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1198 local l="`basename ${lic}`" 1107 local l="`basename ${lic}`"
1199 1108
1200 # here is where we check for the licenses the user already 1109 # here is where we check for the licenses the user already
1201 # accepted ... if we don't find a match, we make the user accept 1110 # accepted ... if we don't find a match, we make the user accept
1202 local shopts=$-
1203 local alic 1111 local alic
1204 set -o noglob #so that bash doesn't expand "*" 1112 eshopts_push -o noglob # so that bash doesn't expand "*"
1205 for alic in ${ACCEPT_LICENSE} ; do 1113 for alic in ${ACCEPT_LICENSE} ; do
1206 if [[ ${alic} == * || ${alic} == ${l} ]]; then 1114 if [[ ${alic} == ${l} ]]; then
1207 set +o noglob; set -${shopts} #reset old shell opts 1115 eshopts_pop
1208 return 0 1116 return 0
1209 fi 1117 fi
1210 done 1118 done
1211 set +o noglob; set -$shopts #reset old shell opts 1119 eshopts_pop
1120 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1212 1121
1213 local licmsg="$(emktemp)" 1122 local licmsg=$(emktemp)
1214 cat << EOF > ${licmsg} 1123 cat <<-EOF > ${licmsg}
1215********************************************************** 1124 **********************************************************
1216The following license outlines the terms of use of this 1125 The following license outlines the terms of use of this
1217package. You MUST accept this license for installation to 1126 package. You MUST accept this license for installation to
1218continue. When you are done viewing, hit 'q'. If you 1127 continue. When you are done viewing, hit 'q'. If you
1219CTRL+C out of this, the install will not run! 1128 CTRL+C out of this, the install will not run!
1220********************************************************** 1129 **********************************************************
1221 1130
1222EOF 1131 EOF
1223 cat ${lic} >> ${licmsg} 1132 cat ${lic} >> ${licmsg}
1224 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}" 1133 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1225 einfon "Do you accept the terms of this license (${l})? [yes/no] " 1134 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1226 read alic 1135 read alic
1227 case ${alic} in 1136 case ${alic} in
1234 die "Failed to accept license" 1143 die "Failed to accept license"
1235 ;; 1144 ;;
1236 esac 1145 esac
1237} 1146}
1238 1147
1148# @FUNCTION: cdrom_get_cds
1149# @USAGE: <file on cd1> [file on cd2] [file on cd3] [...]
1150# @DESCRIPTION:
1239# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates 1151# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1240# the whole 'non-interactive' policy, but damnit I want CD support ! 1152# the whole 'non-interactive' policy, but damnit I want CD support !
1241# 1153#
1242# with these cdrom functions we handle all the user interaction and 1154# With these cdrom functions we handle all the user interaction and
1243# standardize everything. all you have to do is call cdrom_get_cds() 1155# standardize everything. All you have to do is call cdrom_get_cds()
1244# and when the function returns, you can assume that the cd has been 1156# and when the function returns, you can assume that the cd has been
1245# found at CDROM_ROOT. 1157# found at CDROM_ROOT.
1246# 1158#
1159# The function will attempt to locate a cd based upon a file that is on
1160# the cd. The more files you give this function, the more cds
1161# the cdrom functions will handle.
1162#
1247# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2', 1163# Normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1248# etc... if you want to give the cds better names, then just export 1164# etc... If you want to give the cds better names, then just export
1249# the CDROM_NAME_X variables before calling cdrom_get_cds(). 1165# the appropriate CDROM_NAME variable before calling cdrom_get_cds().
1166# Use CDROM_NAME for one cd, or CDROM_NAME_# for multiple cds. You can
1167# also use the CDROM_NAME_SET bash array.
1250# 1168#
1251# for those multi cd ebuilds, see the cdrom_load_next_cd() below. 1169# For those multi cd ebuilds, see the cdrom_load_next_cd() function.
1252#
1253# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1254# - this will attempt to locate a cd based upon a file that is on
1255# the cd ... the more files you give this function, the more cds
1256# the cdrom functions will handle
1257cdrom_get_cds() { 1170cdrom_get_cds() {
1258 # first we figure out how many cds we're dealing with by 1171 # first we figure out how many cds we're dealing with by
1259 # the # of files they gave us 1172 # the # of files they gave us
1260 local cdcnt=0 1173 local cdcnt=0
1261 local f= 1174 local f=
1285 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1198 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1286 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1199 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1287 export CDROM_SET=-1 1200 export CDROM_SET=-1
1288 for f in ${CDROM_CHECK_1//:/ } ; do 1201 for f in ${CDROM_CHECK_1//:/ } ; do
1289 ((++CDROM_SET)) 1202 ((++CDROM_SET))
1290 [[ -e ${CD_ROOT}/${f} ]] && break 1203 [[ -e ${CDROM_ROOT}/${f} ]] && break
1291 done 1204 done
1292 export CDROM_MATCH=${f} 1205 export CDROM_MATCH=${f}
1293 return 1206 return
1294 fi 1207 fi
1295 1208
1305 echo 1218 echo
1306 einfo "For example:" 1219 einfo "For example:"
1307 einfo "export CD_ROOT=/mnt/cdrom" 1220 einfo "export CD_ROOT=/mnt/cdrom"
1308 echo 1221 echo
1309 else 1222 else
1223 if [[ -n ${CDROM_NAME_SET} ]] ; then
1224 # Translate the CDROM_NAME_SET array into CDROM_NAME_#
1225 cdcnt=0
1226 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1227 ((++cdcnt))
1228 export CDROM_NAME_${cdcnt}="${CDROM_NAME_SET[$((${cdcnt}-1))]}"
1229 done
1230 fi
1231
1310 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1232 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1311 cdcnt=0 1233 cdcnt=0
1312 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1234 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1313 ((++cdcnt)) 1235 ((++cdcnt))
1314 var="CDROM_NAME_${cdcnt}" 1236 var="CDROM_NAME_${cdcnt}"
1338 export CDROM_SET="" 1260 export CDROM_SET=""
1339 export CDROM_CURRENT_CD=0 1261 export CDROM_CURRENT_CD=0
1340 cdrom_load_next_cd 1262 cdrom_load_next_cd
1341} 1263}
1342 1264
1343# this is only used when you need access to more than one cd. 1265# @FUNCTION: cdrom_load_next_cd
1344# when you have finished using the first cd, just call this function. 1266# @DESCRIPTION:
1345# when it returns, CDROM_ROOT will be pointing to the second cd. 1267# Some packages are so big they come on multiple CDs. When you're done reading
1346# remember, you can only go forward in the cd chain, you can't go back. 1268# files off a CD and want access to the next one, just call this function.
1269# Again, all the messy details of user interaction are taken care of for you.
1270# Once this returns, just read the variable CDROM_ROOT for the location of the
1271# mounted CD. Note that you can only go forward in the CD list, so make sure
1272# you only call this function when you're done using the current CD.
1347cdrom_load_next_cd() { 1273cdrom_load_next_cd() {
1348 local var 1274 local var
1349 ((++CDROM_CURRENT_CD)) 1275 ((++CDROM_CURRENT_CD))
1350 1276
1351 unset CDROM_ROOT 1277 unset CDROM_ROOT
1368# displayed and we'll hang out here until: 1294# displayed and we'll hang out here until:
1369# (1) the file is found on a mounted cdrom 1295# (1) the file is found on a mounted cdrom
1370# (2) the user hits CTRL+C 1296# (2) the user hits CTRL+C
1371_cdrom_locate_file_on_cd() { 1297_cdrom_locate_file_on_cd() {
1372 local mline="" 1298 local mline=""
1373 local showedmsg=0 1299 local showedmsg=0 showjolietmsg=0
1374 1300
1375 while [[ -z ${CDROM_ROOT} ]] ; do 1301 while [[ -z ${CDROM_ROOT} ]] ; do
1376 local i=0 1302 local i=0
1377 local -a cdset=(${*//:/ }) 1303 local -a cdset=(${*//:/ })
1378 if [[ -n ${CDROM_SET} ]] ; then 1304 if [[ -n ${CDROM_SET} ]] ; then
1381 1307
1382 while [[ -n ${cdset[${i}]} ]] ; do 1308 while [[ -n ${cdset[${i}]} ]] ; do
1383 local dir=$(dirname ${cdset[${i}]}) 1309 local dir=$(dirname ${cdset[${i}]})
1384 local file=$(basename ${cdset[${i}]}) 1310 local file=$(basename ${cdset[${i}]})
1385 1311
1386 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do 1312 local point= node= fs= foo=
1313 while read point node fs foo ; do
1314 [[ " cd9660 iso9660 udf " != *" ${fs} "* ]] && \
1315 ! [[ ${fs} == "subfs" && ",${opts}," == *",fs=cdfss,"* ]] \
1316 && continue
1317 point=${point//\040/ }
1387 [[ -d ${mline}/${dir} ]] || continue 1318 [[ ! -d ${point}/${dir} ]] && continue
1388 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then 1319 [[ -z $(find "${point}/${dir}" -maxdepth 1 -iname "${file}") ]] && continue
1389 export CDROM_ROOT=${mline} 1320 export CDROM_ROOT=${point}
1390 export CDROM_SET=${i} 1321 export CDROM_SET=${i}
1391 export CDROM_MATCH=${cdset[${i}]} 1322 export CDROM_MATCH=${cdset[${i}]}
1392 return 1323 return
1393 fi 1324 done <<< "$(get_mounts)"
1394 done
1395 1325
1396 ((++i)) 1326 ((++i))
1397 done 1327 done
1398 1328
1399 echo 1329 echo
1415 showedmsg=1 1345 showedmsg=1
1416 fi 1346 fi
1417 einfo "Press return to scan for the cd again" 1347 einfo "Press return to scan for the cd again"
1418 einfo "or hit CTRL+C to abort the emerge." 1348 einfo "or hit CTRL+C to abort the emerge."
1419 echo 1349 echo
1350 if [[ ${showjolietmsg} -eq 0 ]] ; then
1351 showjolietmsg=1
1352 else
1420 einfo "If you are having trouble with the detection" 1353 ewarn "If you are having trouble with the detection"
1421 einfo "of your CD, it is possible that you do not have" 1354 ewarn "of your CD, it is possible that you do not have"
1422 einfo "Joliet support enabled in your kernel. Please" 1355 ewarn "Joliet support enabled in your kernel. Please"
1423 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1356 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1357 ebeep 5
1358 fi
1424 read || die "something is screwed with your system" 1359 read || die "something is screwed with your system"
1425 done 1360 done
1426} 1361}
1427 1362
1363# @FUNCTION: strip-linguas
1364# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1365# @DESCRIPTION:
1428# Make sure that LINGUAS only contains languages that 1366# Make sure that LINGUAS only contains languages that
1429# a package can support 1367# a package can support. The first form allows you to
1430# 1368# specify a list of LINGUAS. The -i builds a list of po
1431# usage: strip-linguas <allow LINGUAS> 1369# files found in all the directories and uses the
1432# strip-linguas -i <directories of .po files> 1370# intersection of the lists. The -u builds a list of po
1433# strip-linguas -u <directories of .po files> 1371# files found in all the directories and uses the union
1434# 1372# of the lists.
1435# The first form allows you to specify a list of LINGUAS.
1436# The -i builds a list of po files found in all the
1437# directories and uses the intersection of the lists.
1438# The -u builds a list of po files found in all the
1439# directories and uses the union of the lists.
1440strip-linguas() { 1373strip-linguas() {
1441 local ls newls 1374 local ls newls nols
1442 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1375 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1443 local op=$1; shift 1376 local op=$1; shift
1444 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1377 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1445 local d f 1378 local d f
1446 for d in "$@" ; do 1379 for d in "$@" ; do
1447 if [[ ${op} == "-u" ]] ; then 1380 if [[ ${op} == "-u" ]] ; then
1448 newls=${ls} 1381 newls=${ls}
1449 else 1382 else
1450 newls="" 1383 newls=""
1451 fi 1384 fi
1452 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1385 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1453 if [[ ${op} == "-i" ]] ; then 1386 if [[ ${op} == "-i" ]] ; then
1454 hasq ${f} ${ls} && newls="${newls} ${f}" 1387 has ${f} ${ls} && newls="${newls} ${f}"
1455 else 1388 else
1456 hasq ${f} ${ls} || newls="${newls} ${f}" 1389 has ${f} ${ls} || newls="${newls} ${f}"
1457 fi 1390 fi
1458 done 1391 done
1459 ls=${newls} 1392 ls=${newls}
1460 done 1393 done
1461 else 1394 else
1462 ls="$@" 1395 ls="$@"
1463 fi 1396 fi
1464 1397
1398 nols=""
1465 newls="" 1399 newls=""
1466 for f in ${LINGUAS} ; do 1400 for f in ${LINGUAS} ; do
1467 if hasq ${f} ${ls} ; then 1401 if has ${f} ${ls} ; then
1468 newls="${newls} ${f}" 1402 newls="${newls} ${f}"
1469 else 1403 else
1470 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1404 nols="${nols} ${f}"
1471 fi 1405 fi
1472 done 1406 done
1407 [[ -n ${nols} ]] \
1408 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1473 export LINGUAS=${newls:1} 1409 export LINGUAS=${newls:1}
1474} 1410}
1475 1411
1476# moved from kernel.eclass since they are generally useful outside of 1412# @FUNCTION: preserve_old_lib
1477# kernel.eclass -iggy (20041002) 1413# @USAGE: <libs to preserve> [more libs]
1478 1414# @DESCRIPTION:
1479# the following functions are useful in kernel module ebuilds, etc.
1480# for an example see ivtv or drbd ebuilds
1481
1482# set's ARCH to match what the kernel expects
1483set_arch_to_kernel() {
1484 i=10
1485 while ((i--)) ; do
1486 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1487 done
1488 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1489 case ${ARCH} in
1490 x86) export ARCH="i386";;
1491 amd64) export ARCH="x86_64";;
1492 hppa) export ARCH="parisc";;
1493 mips) export ARCH="mips";;
1494 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1495 *) export ARCH="${ARCH}";;
1496 esac
1497}
1498
1499# set's ARCH back to what portage expects
1500set_arch_to_portage() {
1501 i=10
1502 while ((i--)) ; do
1503 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1504 done
1505 export ARCH="${EUTILS_ECLASS_PORTAGE_ARCH}"
1506}
1507
1508# Jeremy Huddleston <eradicator@gentoo.org>:
1509# preserve_old_lib /path/to/libblah.so.0
1510# preserve_old_lib_notify /path/to/libblah.so.0
1511#
1512# These functions are useful when a lib in your package changes --library. Such 1415# These functions are useful when a lib in your package changes ABI SONAME.
1513# an example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0 1416# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1514# would break packages that link against it. Most people get around this 1417# would break packages that link against it. Most people get around this
1515# by using the portage SLOT mechanism, but that is not always a relevant 1418# by using the portage SLOT mechanism, but that is not always a relevant
1516# solution, so instead you can add the following to your ebuilds: 1419# solution, so instead you can call this from pkg_preinst. See also the
1517# 1420# preserve_old_lib_notify function.
1518# src_install() {
1519# ...
1520# preserve_old_lib /usr/$(get_libdir)/libogg.so.0
1521# ...
1522# }
1523#
1524# pkg_postinst() {
1525# ...
1526# preserve_old_lib_notify /usr/$(get_libdir)/libogg.so.0
1527# ...
1528# }
1529
1530preserve_old_lib() { 1421preserve_old_lib() {
1531 LIB=$1 1422 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1423 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1424 die "Invalid preserve_old_lib() usage"
1425 fi
1426 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1532 1427
1533 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1428 # let portage worry about it
1534 SONAME=`basename ${LIB}` 1429 has preserve-libs ${FEATURES} && return 0
1535 DIRNAME=`dirname ${LIB}`
1536 1430
1537 dodir ${DIRNAME} 1431 local lib dir
1538 cp ${ROOT}${LIB} ${D}${DIRNAME} 1432 for lib in "$@" ; do
1433 [[ -e ${ROOT}/${lib} ]] || continue
1434 dir=${lib%/*}
1435 dodir ${dir} || die "dodir ${dir} failed"
1436 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1539 touch ${D}${LIB} 1437 touch "${D}"/${lib}
1540 fi 1438 done
1541} 1439}
1542 1440
1441# @FUNCTION: preserve_old_lib_notify
1442# @USAGE: <libs to notify> [more libs]
1443# @DESCRIPTION:
1444# Spit helpful messages about the libraries preserved by preserve_old_lib.
1543preserve_old_lib_notify() { 1445preserve_old_lib_notify() {
1544 LIB=$1 1446 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1447 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1448 die "Invalid preserve_old_lib_notify() usage"
1449 fi
1545 1450
1546 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1451 # let portage worry about it
1547 SONAME=`basename ${LIB}` 1452 has preserve-libs ${FEATURES} && return 0
1548 1453
1454 local lib notice=0
1455 for lib in "$@" ; do
1456 [[ -e ${ROOT}/${lib} ]] || continue
1457 if [[ ${notice} -eq 0 ]] ; then
1458 notice=1
1549 ewarn "An old version of an installed library was detected on your system." 1459 ewarn "Old versions of installed libraries were detected on your system."
1550 ewarn "In order to avoid breaking packages that link against it, this older version" 1460 ewarn "In order to avoid breaking packages that depend on these old libs,"
1551 ewarn "is not being removed. In order to make full use of this newer version," 1461 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1552 ewarn "you will need to execute the following command:" 1462 ewarn "in order to remove these old dependencies. If you do not have this"
1463 ewarn "helper program, simply emerge the 'gentoolkit' package."
1464 ewarn
1465 fi
1466 # temp hack for #348634 #357225
1467 [[ ${PN} == "mpfr" ]] && lib=${lib##*/}
1553 ewarn " revdep-rebuild --library ${SONAME}" 1468 ewarn " # revdep-rebuild --library '${lib}'"
1469 done
1470 if [[ ${notice} -eq 1 ]] ; then
1554 ewarn 1471 ewarn
1555 ewarn "After doing that, you can safely remove ${LIB}" 1472 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1556 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild" 1473 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1474 for lib in "$@" ; do
1475 ewarn " # rm '${lib}'"
1476 done
1557 fi 1477 fi
1558} 1478}
1559 1479
1560# Hack for people to figure out if a package was built with 1480# @FUNCTION: built_with_use
1561# certain USE flags 1481# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1482# @DESCRIPTION:
1562# 1483#
1563# Usage: built_with_use [-a|-o] <DEPEND ATOM> <List of USE flags> 1484# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1564# ex: built_with_use xchat gtk2
1565# 1485#
1566# Flags: -a all USE flags should be utilized 1486# A temporary hack until portage properly supports DEPENDing on USE
1567# -o at least one USE flag should be utilized 1487# flags being enabled in packages. This will check to see if the specified
1568# Note: the default flag is '-a' 1488# DEPEND atom was built with the specified list of USE flags. The
1489# --missing option controls the behavior if called on a package that does
1490# not actually support the defined USE flags (aka listed in IUSE).
1491# The default is to abort (call die). The -a and -o flags control
1492# the requirements of the USE flags. They correspond to "and" and "or"
1493# logic. So the -a flag means all listed USE flags must be enabled
1494# while the -o flag means at least one of the listed IUSE flags must be
1495# enabled. The --hidden option is really for internal use only as it
1496# means the USE flag we're checking is hidden expanded, so it won't be found
1497# in IUSE like normal USE flags.
1498#
1499# Remember that this function isn't terribly intelligent so order of optional
1500# flags matter.
1569built_with_use() { 1501built_with_use() {
1502 local hidden="no"
1503 if [[ $1 == "--hidden" ]] ; then
1504 hidden="yes"
1505 shift
1506 fi
1507
1508 local missing_action="die"
1509 if [[ $1 == "--missing" ]] ; then
1510 missing_action=$2
1511 shift ; shift
1512 case ${missing_action} in
1513 true|false|die) ;;
1514 *) die "unknown action '${missing_action}'";;
1515 esac
1516 fi
1517
1570 local opt=$1 1518 local opt=$1
1571 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1519 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1572 1520
1573 local PKG=$(best_version $1) 1521 local PKG=$(best_version $1)
1522 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1574 shift 1523 shift
1575 1524
1576 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE 1525 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1526 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1577 1527
1578 # if the USE file doesnt exist, assume the $PKG is either 1528 # if the IUSE file doesn't exist, the read will error out, we need to handle
1579 # injected or package.provided 1529 # this gracefully
1580 [[ ! -e ${USEFILE} ]] && return 0 1530 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1531 case ${missing_action} in
1532 true) return 0;;
1533 false) return 1;;
1534 die) die "Unable to determine what USE flags $PKG was built with";;
1535 esac
1536 fi
1537
1538 if [[ ${hidden} == "no" ]] ; then
1539 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1540 # Don't check USE_EXPAND #147237
1541 local expand
1542 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1543 if [[ $1 == ${expand}_* ]] ; then
1544 expand=""
1545 break
1546 fi
1547 done
1548 if [[ -n ${expand} ]] ; then
1549 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1550 case ${missing_action} in
1551 true) return 0;;
1552 false) return 1;;
1553 die) die "$PKG does not actually support the $1 USE flag!";;
1554 esac
1555 fi
1556 fi
1557 fi
1581 1558
1582 local USE_BUILT=$(<${USEFILE}) 1559 local USE_BUILT=$(<${USEFILE})
1583 while [[ $# -gt 0 ]] ; do 1560 while [[ $# -gt 0 ]] ; do
1584 if [[ ${opt} = "-o" ]] ; then 1561 if [[ ${opt} = "-o" ]] ; then
1585 has $1 ${USE_BUILT} && return 0 1562 has $1 ${USE_BUILT} && return 0
1589 shift 1566 shift
1590 done 1567 done
1591 [[ ${opt} = "-a" ]] 1568 [[ ${opt} = "-a" ]]
1592} 1569}
1593 1570
1571# @FUNCTION: epunt_cxx
1572# @USAGE: [dir to scan]
1573# @DESCRIPTION:
1594# Many configure scripts wrongly bail when a C++ compiler 1574# Many configure scripts wrongly bail when a C++ compiler could not be
1595# could not be detected. #73450 1575# detected. If dir is not specified, then it defaults to ${S}.
1576#
1577# http://bugs.gentoo.org/73450
1596epunt_cxx() { 1578epunt_cxx() {
1597 local dir=$1 1579 local dir=$1
1598 [[ -z ${dir} ]] && dir=${S} 1580 [[ -z ${dir} ]] && dir=${S}
1599 ebegin "Removing useless C++ checks" 1581 ebegin "Removing useless C++ checks"
1600 local f 1582 local f
1601 for f in $(find ${dir} -name configure) ; do 1583 find "${dir}" -name configure | while read f ; do
1602 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1584 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1603 done 1585 done
1604 eend 0 1586 eend 0
1605} 1587}
1606 1588
1607# dopamd <file> [more files] 1589# @FUNCTION: make_wrapper
1608# 1590# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1609# Install pam auth config file in /etc/pam.d 1591# @DESCRIPTION:
1610dopamd() { 1592# Create a shell wrapper script named wrapper in installpath
1611 [[ -z $1 ]] && die "dopamd requires at least one argument" 1593# (defaults to the bindir) to execute target (default of wrapper) by
1612 1594# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1613 use pam || return 0 1595# libpaths followed by optionally changing directory to chdir.
1614
1615 INSDESTTREE=/etc/pam.d \
1616 doins "$@" || die "failed to install $@"
1617}
1618# newpamd <old name> <new name>
1619#
1620# Install pam file <old name> as <new name> in /etc/pam.d
1621newpamd() {
1622 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1623
1624 use pam || return 0
1625
1626 INSDESTTREE=/etc/pam.d \
1627 newins "$1" "$2" || die "failed to install $1 as $2"
1628}
1629
1630# make a wrapper script ...
1631# NOTE: this was originally games_make_wrapper, but I noticed other places where
1632# this could be used, so I have moved it here and made it not games-specific
1633# -- wolf31o2
1634# $1 == wrapper name
1635# $2 == binary to run
1636# $3 == directory to chdir before running binary
1637# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1638# $5 == path for wrapper
1639make_wrapper() { 1596make_wrapper() {
1640 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5 1597 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1641 local tmpwrapper=$(emktemp) 1598 local tmpwrapper=$(emktemp)
1642 # We don't want to quote ${bin} so that people can pass complex 1599 # We don't want to quote ${bin} so that people can pass complex
1643 # things as $bin ... "./someprog --args" 1600 # things as $bin ... "./someprog --args"
1653fi 1610fi
1654exec ${bin} "\$@" 1611exec ${bin} "\$@"
1655EOF 1612EOF
1656 chmod go+rx "${tmpwrapper}" 1613 chmod go+rx "${tmpwrapper}"
1657 if [[ -n ${path} ]] ; then 1614 if [[ -n ${path} ]] ; then
1615 (
1658 exeinto "${path}" 1616 exeinto "${path}"
1659 newexe "${tmpwrapper}" "${wrapper}" 1617 newexe "${tmpwrapper}" "${wrapper}"
1618 ) || die
1660 else 1619 else
1661 newbin "${tmpwrapper}" "${wrapper}" 1620 newbin "${tmpwrapper}" "${wrapper}" || die
1662 fi 1621 fi
1663} 1622}
1623
1624# @FUNCTION: path_exists
1625# @USAGE: [-a|-o] <paths>
1626# @DESCRIPTION:
1627# Check if the specified paths exist. Works for all types of paths
1628# (files/dirs/etc...). The -a and -o flags control the requirements
1629# of the paths. They correspond to "and" and "or" logic. So the -a
1630# flag means all the paths must exist while the -o flag means at least
1631# one of the paths must exist. The default behavior is "and". If no
1632# paths are specified, then the return value is "false".
1633path_exists() {
1634 local opt=$1
1635 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1636
1637 # no paths -> return false
1638 # same behavior as: [[ -e "" ]]
1639 [[ $# -eq 0 ]] && return 1
1640
1641 local p r=0
1642 for p in "$@" ; do
1643 [[ -e ${p} ]]
1644 : $(( r += $? ))
1645 done
1646
1647 case ${opt} in
1648 -a) return $(( r != 0 )) ;;
1649 -o) return $(( r == $# )) ;;
1650 esac
1651}
1652
1653# @FUNCTION: in_iuse
1654# @USAGE: <flag>
1655# @DESCRIPTION:
1656# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1657# as necessary.
1658#
1659# Note that this function should not be used in the global scope.
1660in_iuse() {
1661 debug-print-function ${FUNCNAME} "${@}"
1662 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1663
1664 local flag=${1}
1665 local liuse=( ${IUSE} )
1666
1667 has "${flag}" "${liuse[@]#[+-]}"
1668}
1669
1670# @FUNCTION: use_if_iuse
1671# @USAGE: <flag>
1672# @DESCRIPTION:
1673# Return true if the given flag is in USE and IUSE.
1674#
1675# Note that this function should not be used in the global scope.
1676use_if_iuse() {
1677 in_iuse $1 || return 1
1678 use $1
1679}
1680
1681# @FUNCTION: usex
1682# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1683# @DESCRIPTION:
1684# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1685# otherwise echo [false output][false suffix] (defaults to "no").
1686usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963

Legend:
Removed from v.1.237  
changed lines
  Added in v.1.368

  ViewVC Help
Powered by ViewVC 1.1.20